candidate(LX,LY,MX,MY) :- leaf(LX,LY,L), node(MX,MY,B,C), L <= B, 0 < C.

2 <= { wire(LX,LY,MX,MY) : candidate(LX,LY,MX,MY) } <= 2 :- leaf(LX,LY,L).

N <= { gateway(MX,MY) : node(MX,MY,B,C) } <= N :- gateways(N).

wire(MX,MY) :- wire(LX,LY,MX,MY).
:- wire(MX,MY), not gateway(MX,MY).

:- node(MX,MY,B,C), #count{ LX,LY : wire(LX,LY,MX,MY) } > C.
:- node(MX,MY,B,C), #sum{ L,LX,LY : wire(LX,LY,MX,MY), leaf(LX,LY,L) } > B.

comp(MX,MY) :- node(MX,MY,B,C), limit(M), M < C.
comp(MX1,MY1,MX2,MY2) :- comp(MX1,MY1), comp(MX2,MY2), MX1 < MX2.
comp(MX ,MY1,MX ,MY2) :- comp(MX ,MY1), comp(MX ,MY2), MY1 < MY2.

drop(MX1,MY1,MX2,MY2,LX,LY) :- comp(MX1,MY1,MX2,MY2), wire(LX,LY,MX1,MY1), wire(LX,LY,MX2,MY2).
:- comp(MX1,MY1,MX2,MY2), limit(M), #count{ LX,LY : drop(MX1,MY1,MX2,MY2,LX,LY) } > M.

dist(LX,LY,MX,MY,X*X+Y*Y) :- candidate(LX,LY,MX,MY), X = MX-LX, Y = MY-LY.
dist(LX,LY,D)             :- dist(LX,LY,MX,MY,D).

less(LX,LY,D) :- dist(LX,LY,D), dist(LX,LY,DD), DD < D.
more(LX,LY,D) :- dist(LX,LY,D), dist(LX,LY,DD), D < DD.

bot(LX,LY,D) :- dist(LX,LY,D), not less(LX,LY,D).
top(LX,LY,D) :- dist(LX,LY,D), not more(LX,LY,D).

have(LX,LY,D) :- dist(LX,LY,MX,MY,D), wire(LX,LY,MX,MY).

smaller(LX,LY,D+1) :- have(LX,LY,D), not top(LX,LY,D).
smaller(LX,LY,D+1) :- smaller(LX,LY,D), not top(LX,LY,D).

penalty(LX,LY,D-1,1) :- have(LX,LY,D), not bot(LX,LY,D), not smaller(LX,LY,D).
penalty(LX,LY,D-1,2) :- have(LX,LY,D), not bot(LX,LY,D).
penalty(LX,LY,D-1,T) :- penalty(LX,LY,D,T), not bot(LX,LY,D).

:~ penalty(LX,LY,D,T). [1,LX,LY,D,T]

#show gateway/2.
#show wire/4.
